Index: uspace/lib/ui/src/menudd.c
===================================================================
--- uspace/lib/ui/src/menudd.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/src/menudd.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,299 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu drop-down
+ *
+ * One of the drop-down menus of a menu bar. This class takes the generic
+ * ui_menu and ties it to the menu bar.
+ */
+
+#include <adt/list.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <str.h>
+#include <ui/accel.h>
+#include <ui/menu.h>
+#include <ui/menudd.h>
+#include <ui/menubar.h>
+#include <ui/resource.h>
+#include "../private/menubar.h"
+#include "../private/menudd.h"
+
+static void ui_menu_dd_left(ui_menu_t *, void *, sysarg_t);
+static void ui_menu_dd_right(ui_menu_t *, void *, sysarg_t);
+static void ui_menu_dd_close_req(ui_menu_t *, void *);
+static void ui_menu_dd_press_accel(ui_menu_t *, void *, char32_t, sysarg_t);
+
+static ui_menu_cb_t ui_menu_dd_menu_cb = {
+	.left = ui_menu_dd_left,
+	.right = ui_menu_dd_right,
+	.close_req = ui_menu_dd_close_req,
+	.press_accel = ui_menu_dd_press_accel
+};
+
+/** Create new menu drop-down.
+ *
+ * @param mbar Menu bar
+ * @param caption Caption
+ * @param rmdd Place to store pointer to new menu drop-down or @c NULL
+ * @param rmenu Place to store pointer to new menu or @c NULL
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_menu_dd_create(ui_menu_bar_t *mbar, const char *caption,
+    ui_menu_dd_t **rmdd, ui_menu_t **rmenu)
+{
+	errno_t rc;
+	ui_menu_dd_t *mdd;
+
+	mdd = calloc(1, sizeof(ui_menu_dd_t));
+	if (mdd == NULL)
+		return ENOMEM;
+
+	mdd->caption = str_dup(caption);
+	if (mdd->caption == NULL) {
+		free(mdd);
+		return ENOMEM;
+	}
+
+	/* Create menu */
+	rc = ui_menu_create(mbar->window, &mdd->menu);
+	if (rc != EOK) {
+		free(mdd->caption);
+		free(mdd);
+		return rc;
+	}
+
+	mdd->mbar = mbar;
+	list_append(&mdd->lmenudds, &mbar->menudds);
+
+	ui_menu_set_cb(mdd->menu, &ui_menu_dd_menu_cb, (void *)mdd);
+
+	if (rmdd != NULL)
+		*rmdd = mdd;
+	if (rmenu != NULL)
+		*rmenu = mdd->menu;
+	return EOK;
+}
+
+/** Destroy menu drop-down.
+ *
+ * @param menu Menu or @c NULL
+ */
+void ui_menu_dd_destroy(ui_menu_dd_t *mdd)
+{
+	if (mdd == NULL)
+		return;
+
+	/* Destroy menu */
+	ui_menu_destroy(mdd->menu);
+
+	list_remove(&mdd->lmenudds);
+	free(mdd->caption);
+	free(mdd);
+}
+
+/** Get first menu drop-down in menu bar.
+ *
+ * @param mbar Menu bar
+ * @return First menu or @c NULL if there is none
+ */
+ui_menu_dd_t *ui_menu_dd_first(ui_menu_bar_t *mbar)
+{
+	link_t *link;
+
+	link = list_first(&mbar->menudds);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ui_menu_dd_t, lmenudds);
+}
+
+/** Get next menu drop-down in menu bar.
+ *
+ * @param cur Current menu drop-down
+ * @return Next menu drop-down or @c NULL if @a cur is the last one
+ */
+ui_menu_dd_t *ui_menu_dd_next(ui_menu_dd_t *cur)
+{
+	link_t *link;
+
+	link = list_next(&cur->lmenudds, &cur->mbar->menudds);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ui_menu_dd_t, lmenudds);
+}
+
+/** Get last menu drop-down in menu bar.
+ *
+ * @param mbar Menu bar
+ * @return Last menu drop-down or @c NULL if there is none
+ */
+ui_menu_dd_t *ui_menu_dd_last(ui_menu_bar_t *mbar)
+{
+	link_t *link;
+
+	link = list_last(&mbar->menudds);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ui_menu_dd_t, lmenudds);
+}
+
+/** Get previous menu drop-down in menu bar.
+ *
+ * @param cur Current menu drop-down
+ * @return Previous menu drop-down or @c NULL if @a cur is the fist one
+ */
+ui_menu_dd_t *ui_menu_dd_prev(ui_menu_dd_t *cur)
+{
+	link_t *link;
+
+	link = list_prev(&cur->lmenudds, &cur->mbar->menudds);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ui_menu_dd_t, lmenudds);
+}
+
+/** Get menu drop-down caption.
+ *
+ * @param mdd Menu drop-down
+ * @return Caption (owned by @a menu)
+ */
+const char *ui_menu_dd_caption(ui_menu_dd_t *mdd)
+{
+	return mdd->caption;
+}
+
+/** Get menu drop-down accelerator character.
+ *
+ * @param mdd Menu drop-down
+ * @return Accelerator character (lowercase) or the null character if
+ *         the menu has no accelerator.
+ */
+char32_t ui_menu_dd_get_accel(ui_menu_dd_t *mdd)
+{
+	return ui_accel_get(mdd->caption);
+}
+
+/** Open menu drop-down.
+ *
+ * @param mdd Menu drop-down
+ * @param prect Parent rectangle around which the drop-down should be placed
+ * @param idev_id Input device associated with the drop-down's seat
+ */
+errno_t ui_menu_dd_open(ui_menu_dd_t *mdd, gfx_rect_t *prect, sysarg_t idev_id)
+{
+	return ui_menu_open(mdd->menu, prect, idev_id);
+}
+
+/** Close menu drop-down.
+ *
+ * @param mdd Menu drop-down
+ */
+void ui_menu_dd_close(ui_menu_dd_t *mdd)
+{
+	ui_menu_close(mdd->menu);
+}
+
+/** Determine if menu drop-down is open.
+ *
+ * @param mdd Menu drop-down
+ * @return @c true iff menu drop-down is open
+ */
+bool ui_menu_dd_is_open(ui_menu_dd_t *mdd)
+{
+	return ui_menu_is_open(mdd->menu);
+}
+
+/** Handle menu left event.
+ *
+ * @param menu Menu
+ * @param arg Argument (ui_menu_dd_t *)
+ * @param idev_id Input device ID
+ */
+static void ui_menu_dd_left(ui_menu_t *menu, void *arg, sysarg_t idev_id)
+{
+	ui_menu_dd_t *mdd = (ui_menu_dd_t *)arg;
+
+	(void)menu;
+
+	ui_menu_bar_left(mdd->mbar, idev_id);
+}
+
+/** Handle menu right event.
+ *
+ * @param menu Menu
+ * @param arg Argument (ui_menu_dd_t *)
+ * @param idev_id Input device ID
+ */
+static void ui_menu_dd_right(ui_menu_t *menu, void *arg, sysarg_t idev_id)
+{
+	ui_menu_dd_t *mdd = (ui_menu_dd_t *)arg;
+
+	(void)menu;
+
+	ui_menu_bar_right(mdd->mbar, idev_id);
+}
+
+/** Handle menu close request.
+ *
+ * @param menu Menu
+ * @param arg Argument (ui_menu_dd_t *)
+ */
+static void ui_menu_dd_close_req(ui_menu_t *menu, void *arg)
+{
+	ui_menu_dd_t *mdd = (ui_menu_dd_t *)arg;
+
+	(void)menu;
+	ui_menu_bar_deactivate(mdd->mbar);
+}
+
+/** Handle menu accelerator key press event.
+ *
+ * @param menu Menu
+ * @param arg Argument (ui_menu_dd_t *)
+ * @param c Character
+ * @param kbd_id Keyboard ID
+ */
+static void ui_menu_dd_press_accel(ui_menu_t *menu, void *arg, char32_t c,
+    sysarg_t kbd_id)
+{
+	ui_menu_dd_t *mdd = (ui_menu_dd_t *)arg;
+
+	(void)menu;
+	ui_menu_bar_press_accel(mdd->mbar, c, kbd_id);
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/menuentry.c
===================================================================
--- uspace/lib/ui/src/menuentry.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/menuentry.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -43,6 +43,8 @@
 #include <stdlib.h>
 #include <str.h>
+#include <ui/accel.h>
 #include <ui/control.h>
 #include <ui/paint.h>
+#include <ui/menubar.h>
 #include <ui/menuentry.h>
 #include <ui/window.h>
@@ -143,5 +145,20 @@
 		return;
 
+	mentry->menu->total_h -= ui_menu_entry_height(mentry);
+	/* NOTE: max_caption_w/max_shortcut_w not updated (speed) */
+
 	list_remove(&mentry->lentries);
+
+	/*
+	 * If we emptied the menu, reset accumulated dims so they
+	 * can be correctly calculated when (if) the menu is
+	 * re-populated.
+	 */
+	if (list_empty(&mentry->menu->entries)) {
+		mentry->menu->total_h = 0;
+		mentry->menu->max_caption_w = 0;
+		mentry->menu->max_shortcut_w = 0;
+	}
+
 	free(mentry->caption);
 	free(mentry);
@@ -159,4 +176,24 @@
 	mentry->cb = cb;
 	mentry->arg = arg;
+}
+
+/** Set menu entry disabled flag.
+ *
+ * @param mentry Menu entry
+ * @param disabled @c true iff entry is to be disabled, @c false otherwise
+ */
+void ui_menu_entry_set_disabled(ui_menu_entry_t *mentry, bool disabled)
+{
+	mentry->disabled = disabled;
+}
+
+/** Get menu entry disabled flag.
+ *
+ * @param mentry Menu entry
+ * @return disabled @c true iff entry is disabled, @c false otherwise
+ */
+bool ui_menu_entry_is_disabled(ui_menu_entry_t *mentry)
+{
+	return mentry->disabled;
 }
 
@@ -177,4 +214,20 @@
 }
 
+/** Get last menu entry in menu.
+ *
+ * @param menu Menu
+ * @return Last menu entry or @c NULL if there is none
+ */
+ui_menu_entry_t *ui_menu_entry_last(ui_menu_t *menu)
+{
+	link_t *link;
+
+	link = list_last(&menu->entries);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ui_menu_entry_t, lentries);
+}
+
 /** Get next menu entry in menu.
  *
@@ -193,4 +246,20 @@
 }
 
+/** Get previous menu entry in menu.
+ *
+ * @param cur Current menu entry
+ * @return Next menu entry or @c NULL if @a cur is the last one
+ */
+ui_menu_entry_t *ui_menu_entry_prev(ui_menu_entry_t *cur)
+{
+	link_t *link;
+
+	link = list_prev(&cur->lentries, &cur->menu->entries);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ui_menu_entry_t, lentries);
+}
+
 /** Get width of menu entry.
  *
@@ -207,11 +276,11 @@
 	 * This needs to work even if the menu is not open, so we cannot
 	 * use the menu's resource, which is only created after the menu
-	 * is open (and its window is created). Use the menu bar's
+	 * is open (and its window is created). Use the parent window's
 	 * resource instead.
 	 */
-	res = ui_window_get_res(mentry->menu->mbar->window);
-
-	*caption_w = gfx_text_width(res->font, mentry->caption);
-	*shortcut_w = gfx_text_width(res->font, mentry->shortcut);
+	res = ui_window_get_res(mentry->menu->parent);
+
+	*caption_w = ui_text_width(res->font, mentry->caption);
+	*shortcut_w = ui_text_width(res->font, mentry->shortcut);
 }
 
@@ -233,8 +302,8 @@
 	 * This needs to work even if the menu is not open, so we cannot
 	 * use the menu's resource, which is only created after the menu
-	 * is open (and its window is created). Use the menu bar's
+	 * is open (and its window is created). Use the parent window's
 	 * resource instead.
 	 */
-	res = ui_window_get_res(menu->mbar->window);
+	res = ui_window_get_res(menu->parent);
 
 	if (res->textmode)
@@ -272,8 +341,8 @@
 	 * This needs to work even if the menu is not open, so we cannot
 	 * use the menu's resource, which is only created after the menu
-	 * is open (and its window is created). Use the menu bar's
+	 * is open (and its window is created). Use the parent window's
 	 * resource instead.
 	 */
-	res = ui_window_get_res(mentry->menu->mbar->window);
+	res = ui_window_get_res(mentry->menu->parent);
 
 	if (res->textmode) {
@@ -298,4 +367,15 @@
 }
 
+/** Get menu entry accelerator character.
+ *
+ * @param mentry Menu entry
+ * @return Accelerator character (lowercase) or the null character if
+ *         the menu entry has no accelerator.
+ */
+char32_t ui_menu_entry_get_accel(ui_menu_entry_t *mentry)
+{
+	return ui_accel_get(mentry->caption);
+}
+
 /** Paint menu entry.
  *
@@ -307,5 +387,5 @@
 {
 	ui_resource_t *res;
-	gfx_text_fmt_t fmt;
+	ui_text_fmt_t fmt;
 	gfx_color_t *bg_color;
 	ui_menu_entry_geom_t geom;
@@ -317,5 +397,6 @@
 	ui_menu_entry_get_geom(mentry, pos, &geom);
 
-	gfx_text_fmt_init(&fmt);
+	ui_text_fmt_init(&fmt);
+	fmt.font = res->font;
 	fmt.halign = gfx_halign_left;
 	fmt.valign = gfx_valign_top;
@@ -324,7 +405,13 @@
 	    mentry == mentry->menu->selected) {
 		fmt.color = res->wnd_sel_text_color;
+		fmt.hgl_color = res->wnd_sel_text_hgl_color;
 		bg_color = res->wnd_sel_text_bg_color;
+	} else if (mentry->disabled) {
+		fmt.color = res->wnd_dis_text_color;
+		fmt.hgl_color = res->wnd_dis_text_color;
+		bg_color = res->wnd_face_color;
 	} else {
 		fmt.color = res->wnd_text_color;
+		fmt.hgl_color = res->wnd_text_hgl_color;
 		bg_color = res->wnd_face_color;
 	}
@@ -338,5 +425,5 @@
 		goto error;
 
-	rc = gfx_puttext(res->font, &geom.caption_pos, &fmt, mentry->caption);
+	rc = ui_paint_text(&geom.caption_pos, &fmt, mentry->caption);
 	if (rc != EOK)
 		goto error;
@@ -344,5 +431,5 @@
 	fmt.halign = gfx_halign_right;
 
-	rc = gfx_puttext(res->font, &geom.shortcut_pos, &fmt, mentry->shortcut);
+	rc = ui_paint_text(&geom.shortcut_pos, &fmt, mentry->shortcut);
 	if (rc != EOK)
 		goto error;
@@ -378,4 +465,13 @@
 }
 
+/** Determine if entry is selectable.
+ *
+ * @return @c true iff entry is selectable
+ */
+bool ui_menu_entry_selectable(ui_menu_entry_t *mentry)
+{
+	return !mentry->separator;
+}
+
 /** Handle button press in menu entry.
  *
@@ -388,5 +484,5 @@
 		return;
 
-	if (mentry->separator)
+	if (mentry->separator || mentry->disabled)
 		return;
 
@@ -407,11 +503,19 @@
 	mentry->held = false;
 
-	if (mentry->inside) {
-		/* Close menu */
-		ui_menu_bar_select(mentry->menu->mbar, NULL, NULL);
-
-		/* Call back */
-		ui_menu_entry_cb(mentry);
-	}
+	if (mentry->inside)
+		ui_menu_entry_activate(mentry);
+}
+
+/** Activate menu entry.
+ *
+ * @param mentry Menu entry
+ */
+void ui_menu_entry_activate(ui_menu_entry_t *mentry)
+{
+	/* Close menu */
+	ui_menu_close_req(mentry->menu);
+
+	/* Call back */
+	ui_menu_entry_cb(mentry);
 }
 
@@ -497,4 +601,6 @@
 		}
 		break;
+	case POS_DCLICK:
+		break;
 	}
 
Index: uspace/lib/ui/src/paint.c
===================================================================
--- uspace/lib/ui/src/paint.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/paint.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,4 +39,5 @@
 #include <gfx/render.h>
 #include <gfx/text.h>
+#include <ui/accel.h>
 #include <ui/paint.h>
 #include <stdlib.h>
@@ -359,14 +360,289 @@
 }
 
-/** Paint a text box.
+/** Paint upward pointing triangle.
+ *
+ * @param gc Graphic context
+ * @param pos Center position
+ * @param n Length of triangle side
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_up_triangle(gfx_context_t *gc, gfx_coord2_t *pos,
+    gfx_coord_t n)
+{
+	gfx_coord_t i;
+	errno_t rc;
+	gfx_rect_t rect;
+
+	for (i = 0; i < n; i++) {
+		rect.p0.x = pos->x - i;
+		rect.p0.y = pos->y - n / 2 + i;
+		rect.p1.x = pos->x + i + 1;
+		rect.p1.y = pos->y - n / 2 + i + 1;
+		rc = gfx_fill_rect(gc, &rect);
+		if (rc != EOK)
+			return rc;
+	}
+
+	return EOK;
+}
+
+/** Paint downward pointing triangle.
+ *
+ * @param gc Graphic context
+ * @param pos Center position
+ * @param n Length of triangle side
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_down_triangle(gfx_context_t *gc, gfx_coord2_t *pos,
+    gfx_coord_t n)
+{
+	gfx_coord_t i;
+	errno_t rc;
+	gfx_rect_t rect;
+
+	for (i = 0; i < n; i++) {
+		rect.p0.x = pos->x - i;
+		rect.p0.y = pos->y + n / 2 - i;
+		rect.p1.x = pos->x + i + 1;
+		rect.p1.y = pos->y + n / 2 - i + 1;
+		rc = gfx_fill_rect(gc, &rect);
+		if (rc != EOK)
+			return rc;
+	}
+
+	return EOK;
+}
+
+/** Paint left pointing triangle.
+ *
+ * @param gc Graphic context
+ * @param pos Center position
+ * @param n Length of triangle side
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_left_triangle(gfx_context_t *gc, gfx_coord2_t *pos,
+    gfx_coord_t n)
+{
+	gfx_coord_t i;
+	errno_t rc;
+	gfx_rect_t rect;
+
+	for (i = 0; i < n; i++) {
+		rect.p0.x = pos->x - n / 2 + i;
+		rect.p0.y = pos->y - i;
+		rect.p1.x = pos->x - n / 2 + i + 1;
+		rect.p1.y = pos->y + i + 1;
+		rc = gfx_fill_rect(gc, &rect);
+		if (rc != EOK)
+			return rc;
+	}
+
+	return EOK;
+}
+
+/** Paint right pointing triangle.
+ *
+ * @param gc Graphic context
+ * @param pos Center position
+ * @param n Length of triangle side
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_right_triangle(gfx_context_t *gc, gfx_coord2_t *pos,
+    gfx_coord_t n)
+{
+	gfx_coord_t i;
+	errno_t rc;
+	gfx_rect_t rect;
+
+	for (i = 0; i < n; i++) {
+		rect.p0.x = pos->x + n / 2 - i;
+		rect.p0.y = pos->y - i;
+		rect.p1.x = pos->x + n / 2 - i + 1;
+		rect.p1.y = pos->y + i + 1;
+		rc = gfx_fill_rect(gc, &rect);
+		if (rc != EOK)
+			return rc;
+	}
+
+	return EOK;
+}
+
+/** Paint diagonal cross (X).
+ *
+ * @param gc Graphic context
+ * @param pos Center position
+ * @param n Length of each leg
+ * @param w Pen width
+ * @param h Pen height
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_cross(gfx_context_t *gc, gfx_coord2_t *pos,
+    gfx_coord_t n, gfx_coord_t w, gfx_coord_t h)
+{
+	gfx_coord_t i;
+	gfx_rect_t rect;
+	errno_t rc;
+
+	rect.p0.x = pos->x;
+	rect.p0.y = pos->y;
+	rect.p1.x = pos->x + w;
+	rect.p1.y = pos->y + h;
+	rc = gfx_fill_rect(gc, &rect);
+	if (rc != EOK)
+		return rc;
+
+	for (i = 1; i < n; i++) {
+		rect.p0.x = pos->x - i;
+		rect.p0.y = pos->y - i;
+		rect.p1.x = pos->x - i + w;
+		rect.p1.y = pos->y - i + h;
+		rc = gfx_fill_rect(gc, &rect);
+		if (rc != EOK)
+			return rc;
+
+		rect.p0.x = pos->x - i;
+		rect.p0.y = pos->y + i;
+		rect.p1.x = pos->x - i + w;
+		rect.p1.y = pos->y + i + h;
+		rc = gfx_fill_rect(gc, &rect);
+		if (rc != EOK)
+			return rc;
+
+		rect.p0.x = pos->x + i;
+		rect.p0.y = pos->y - i;
+		rect.p1.x = pos->x + i + w;
+		rect.p1.y = pos->y - i + h;
+		rc = gfx_fill_rect(gc, &rect);
+		if (rc != EOK)
+			return rc;
+
+		rect.p0.x = pos->x + i;
+		rect.p0.y = pos->y + i;
+		rect.p1.x = pos->x + i + w;
+		rect.p1.y = pos->y + i + h;
+		rc = gfx_fill_rect(gc, &rect);
+		if (rc != EOK)
+			return rc;
+	}
+
+	return EOK;
+}
+
+/** Paint minimize icon.
+ *
+ * @param resource UI resource
+ * @param pos Center position
+ * @param w Icon width
+ * @param h Icon height
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_minicon(ui_resource_t *resource, gfx_coord2_t *pos,
+    gfx_coord_t w, gfx_coord_t h)
+{
+	gfx_rect_t rect;
+	errno_t rc;
+
+	rc = gfx_set_color(resource->gc, resource->btn_text_color);
+	if (rc != EOK)
+		return rc;
+
+	rect.p0.x = pos->x - w / 2;
+	rect.p0.y = pos->y + h / 2 - 2;
+	rect.p1.x = rect.p0.x + w;
+	rect.p1.y = rect.p0.y + 2;
+	rc = gfx_fill_rect(resource->gc, &rect);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
+/** Paint maximize icon.
+ *
+ * @param resource UI resource
+ * @param pos Center position
+ * @param w Icon width
+ * @param h Icon height
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_maxicon(ui_resource_t *resource, gfx_coord2_t *pos,
+    gfx_coord_t w, gfx_coord_t h)
+{
+	gfx_rect_t rect;
+	errno_t rc;
+
+	rc = gfx_set_color(resource->gc, resource->btn_text_color);
+	if (rc != EOK)
+		return rc;
+
+	rect.p0.x = pos->x - w / 2;
+	rect.p0.y = pos->y - h / 2;
+	rect.p1.x = rect.p0.x + w;
+	rect.p1.y = rect.p0.y + h;
+	rc = gfx_fill_rect(resource->gc, &rect);
+	if (rc != EOK)
+		return rc;
+
+	rc = gfx_set_color(resource->gc, resource->btn_face_color);
+	if (rc != EOK)
+		return rc;
+
+	rect.p0.x += 1;
+	rect.p0.y += 2;
+	rect.p1.x -= 1;
+	rect.p1.y -= 1;
+	rc = gfx_fill_rect(resource->gc, &rect);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
+/** Paint unmaximize icon.
+ *
+ * Unmaximize icon consists of two overlapping window icons.
+ *
+ * @param resource UI resource
+ * @param pos Center position
+ * @param w Window icon width
+ * @param h Window icon height
+ * @param dw Horizontal distance between window icon centers
+ * @param dh Vertical distance between window icon centers
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_unmaxicon(ui_resource_t *resource, gfx_coord2_t *pos,
+    gfx_coord_t w, gfx_coord_t h, gfx_coord_t dw, gfx_coord_t dh)
+{
+	gfx_coord2_t p;
+	errno_t rc;
+
+	p.x = pos->x + dw / 2;
+	p.y = pos->y - dh / 2;
+	rc = ui_paint_maxicon(resource, &p, w, h);
+	if (rc != EOK)
+		return rc;
+
+	p.x = pos->x - dw / 2;
+	p.y = pos->y + dh / 2;
+	rc = ui_paint_maxicon(resource, &p, w, h);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
+/** Paint a custom text box.
+ *
+ * Paint a text box using user-provided box chars.
  *
  * @param resource UI resource
  * @param rect Rectangle inside which to paint the box
  * @param style Box style
+ * @param boxc Box characters
  * @param color Color
  * @return EOK on success or an error code
  */
-errno_t ui_paint_text_box(ui_resource_t *resource, gfx_rect_t *rect,
-    ui_box_style_t style, gfx_color_t *color)
+errno_t ui_paint_text_box_custom(ui_resource_t *resource, gfx_rect_t *rect,
+    ui_box_chars_t *boxc, gfx_color_t *color)
 {
 	errno_t rc;
@@ -380,5 +656,4 @@
 	gfx_coord_t y;
 	char *str = NULL;
-	ui_box_chars_t *boxc = NULL;
 
 	gfx_rect_points_sort(rect, &srect);
@@ -388,4 +663,93 @@
 	if (dim.x < 2 || dim.y < 2)
 		return EOK;
+
+	gfx_text_fmt_init(&fmt);
+	fmt.font = resource->font;
+	fmt.color = color;
+
+	bufsz = str_size(boxc->c[0][0]) +
+	    str_size(boxc->c[0][1]) * (dim.x - 2) +
+	    str_size(boxc->c[0][2]) + 1;
+
+	str = malloc(bufsz);
+	if (str == NULL)
+		return ENOMEM;
+
+	/* Top edge and corners */
+
+	str_cpy(str, bufsz, boxc->c[0][0]);
+	off = str_size(boxc->c[0][0]);
+
+	for (i = 1; i < dim.x - 1; i++) {
+		str_cpy(str + off, bufsz - off, boxc->c[0][1]);
+		off += str_size(boxc->c[0][1]);
+	}
+
+	str_cpy(str + off, bufsz - off, boxc->c[0][2]);
+	off += str_size(boxc->c[0][2]);
+	str[off] = '\0';
+
+	pos = rect->p0;
+	rc = gfx_puttext(&pos, &fmt, str);
+	if (rc != EOK)
+		goto error;
+
+	/* Vertical edges */
+	for (y = rect->p0.y + 1; y < rect->p1.y - 1; y++) {
+		pos.y = y;
+
+		pos.x = rect->p0.x;
+		rc = gfx_puttext(&pos, &fmt, boxc->c[1][0]);
+		if (rc != EOK)
+			goto error;
+
+		pos.x = rect->p1.x - 1;
+		rc = gfx_puttext(&pos, &fmt, boxc->c[1][2]);
+		if (rc != EOK)
+			goto error;
+	}
+
+	/* Bottom edge and corners */
+
+	str_cpy(str, bufsz, boxc->c[2][0]);
+	off = str_size(boxc->c[2][0]);
+
+	for (i = 1; i < dim.x - 1; i++) {
+		str_cpy(str + off, bufsz - off, boxc->c[2][1]);
+		off += str_size(boxc->c[2][1]);
+	}
+
+	str_cpy(str + off, bufsz - off, boxc->c[2][2]);
+	off += str_size(boxc->c[2][2]);
+	str[off] = '\0';
+
+	pos.x = rect->p0.x;
+	pos.y = rect->p1.y - 1;
+	rc = gfx_puttext(&pos, &fmt, str);
+	if (rc != EOK)
+		goto error;
+
+	free(str);
+	return EOK;
+error:
+	if (str != NULL)
+		free(str);
+	return rc;
+}
+
+/** Paint a text box.
+ *
+ * Paint a text box with the specified style.
+ *
+ * @param resource UI resource
+ * @param rect Rectangle inside which to paint the box
+ * @param style Box style
+ * @param color Color
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_text_box(ui_resource_t *resource, gfx_rect_t *rect,
+    ui_box_style_t style, gfx_color_t *color)
+{
+	ui_box_chars_t *boxc = NULL;
 
 	switch (style) {
@@ -401,77 +765,5 @@
 		return EINVAL;
 
-	gfx_text_fmt_init(&fmt);
-	fmt.color = color;
-
-	bufsz = str_size(boxc->c[0][0]) +
-	    str_size(boxc->c[0][1]) * (dim.x - 2) +
-	    str_size(boxc->c[0][2]) + 1;
-
-	str = malloc(bufsz);
-	if (str == NULL)
-		return ENOMEM;
-
-	/* Top edge and corners */
-
-	str_cpy(str, bufsz, boxc->c[0][0]);
-	off = str_size(boxc->c[0][0]);
-
-	for (i = 1; i < dim.x - 1; i++) {
-		str_cpy(str + off, bufsz - off, boxc->c[0][1]);
-		off += str_size(boxc->c[0][1]);
-	}
-
-	str_cpy(str + off, bufsz - off, boxc->c[0][2]);
-	off += str_size(boxc->c[0][2]);
-	str[off] = '\0';
-
-	pos = rect->p0;
-	rc = gfx_puttext(resource->font, &pos, &fmt, str);
-	if (rc != EOK)
-		goto error;
-
-	/* Vertical edges */
-	for (y = rect->p0.y + 1; y < rect->p1.y - 1; y++) {
-		pos.y = y;
-
-		pos.x = rect->p0.x;
-		rc = gfx_puttext(resource->font, &pos, &fmt,
-		    boxc->c[1][0]);
-		if (rc != EOK)
-			goto error;
-
-		pos.x = rect->p1.x - 1;
-		rc = gfx_puttext(resource->font, &pos, &fmt,
-		    boxc->c[1][2]);
-		if (rc != EOK)
-			goto error;
-	}
-
-	/* Bottom edge and corners */
-
-	str_cpy(str, bufsz, boxc->c[2][0]);
-	off = str_size(boxc->c[2][0]);
-
-	for (i = 1; i < dim.x - 1; i++) {
-		str_cpy(str + off, bufsz - off, boxc->c[2][1]);
-		off += str_size(boxc->c[2][1]);
-	}
-
-	str_cpy(str + off, bufsz - off, boxc->c[2][2]);
-	off += str_size(boxc->c[2][2]);
-	str[off] = '\0';
-
-	pos.x = rect->p0.x;
-	pos.y = rect->p1.y - 1;
-	rc = gfx_puttext(resource->font, &pos, &fmt, str);
-	if (rc != EOK)
-		goto error;
-
-	free(str);
-	return EOK;
-error:
-	if (str != NULL)
-		free(str);
-	return rc;
+	return ui_paint_text_box_custom(resource, rect, boxc, color);
 }
 
@@ -519,4 +811,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = resource->font;
 	fmt.color = color;
 
@@ -542,5 +835,5 @@
 
 	pos = rect->p0;
-	rc = gfx_puttext(resource->font, &pos, &fmt, str);
+	rc = gfx_puttext(&pos, &fmt, str);
 	if (rc != EOK)
 		goto error;
@@ -554,4 +847,157 @@
 }
 
+/** Fill rectangle with text character.
+ *
+ * @param resource UI resource
+ * @param rect Rectangle
+ * @param color Color
+ * @param gchar Character to fill with
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_text_rect(ui_resource_t *resource, gfx_rect_t *rect,
+    gfx_color_t *color, const char *gchar)
+{
+	gfx_coord2_t pos;
+	gfx_text_fmt_t fmt;
+	gfx_rect_t srect;
+	gfx_coord_t w, i;
+	char *buf;
+	size_t gcharsz;
+	errno_t rc;
+
+	gfx_rect_points_sort(rect, &srect);
+
+	gfx_text_fmt_init(&fmt);
+	fmt.font = resource->font;
+	fmt.color = color;
+	fmt.halign = gfx_halign_left;
+	fmt.valign = gfx_valign_top;
+
+	w = srect.p1.x - srect.p0.x;
+	if (w == 0)
+		return EOK;
+
+	gcharsz = str_size(gchar);
+
+	buf = malloc(w * gcharsz + 1);
+	if (buf == NULL)
+		return ENOMEM;
+
+	for (i = 0; i < w; i++)
+		str_cpy(buf + i * gcharsz, (w - i) * gcharsz + 1, gchar);
+	buf[w * gcharsz] = '\0';
+
+	pos.x = srect.p0.x;
+	for (pos.y = srect.p0.y; pos.y < srect.p1.y; pos.y++) {
+		rc = gfx_puttext(&pos, &fmt, buf);
+		if (rc != EOK)
+			goto error;
+	}
+
+	free(buf);
+	return EOK;
+error:
+	free(buf);
+	return rc;
+}
+
+/** Initialize UI text formatting structure.
+ *
+ * UI text formatting structure must always be initialized using this function
+ * first.
+ *
+ * @param fmt UI text formatting structure
+ */
+void ui_text_fmt_init(ui_text_fmt_t *fmt)
+{
+	memset(fmt, 0, sizeof(ui_text_fmt_t));
+}
+
+/** Compute UI text width.
+ *
+ * @param font Font
+ * @param str String
+ * @return Text width
+ */
+gfx_coord_t ui_text_width(gfx_font_t *font, const char *str)
+{
+	gfx_coord_t w;
+	gfx_coord_t tw;
+	const char *sp;
+
+	/* Text including tildes */
+	w = gfx_text_width(font, str);
+	tw = gfx_text_width(font, "~");
+
+	/* Subtract width of singular tildes */
+	sp = str;
+	while (*sp != '\0') {
+		if (*sp == '~' && sp[1] != '~')
+			w -= tw;
+		++sp;
+	}
+
+	return w;
+}
+
+/** Paint text (with highlighting markup).
+ *
+ * Paint some text with highlighted sections enclosed with tilde characters
+ * ('~'). A literal tilde can be printed with "~~". Text can be highlighted
+ * with an underline or different color, based on display capabilities.
+ *
+ * @param pos Anchor position
+ * @param fmt Text formatting
+ * @param str String containing '~' markup
+ *
+ * @return EOK on success or an error code
+ */
+errno_t ui_paint_text(gfx_coord2_t *pos, ui_text_fmt_t *fmt, const char *str)
+{
+	gfx_coord2_t tpos;
+	gfx_text_fmt_t tfmt;
+	char *buf;
+	char *endptr;
+	const char *sp;
+	errno_t rc;
+
+	/* Break down string into list of (non)highlighted parts */
+	rc = ui_accel_process(str, &buf, &endptr);
+	if (rc != EOK)
+		return rc;
+
+	gfx_text_fmt_init(&tfmt);
+	tfmt.font = fmt->font;
+	tfmt.color = fmt->color;
+	tfmt.halign = fmt->halign;
+	tfmt.width = fmt->width;
+	tfmt.valign = fmt->valign;
+	tfmt.underline = false;
+
+	tpos = *pos;
+	sp = buf;
+	while (sp != endptr) {
+		/* Print the current string */
+		rc = gfx_puttext(&tpos, &tfmt, sp);
+		if (rc != EOK)
+			goto error;
+
+		gfx_text_cont(&tpos, &tfmt, sp, &tpos, &tfmt);
+		tfmt.underline = !tfmt.underline;
+		tfmt.color = tfmt.underline ? fmt->hgl_color : fmt->color;
+
+		/* Skip to the next string */
+		while (*sp != '\0')
+			++sp;
+		++sp;
+	}
+
+	free(buf);
+	return EOK;
+error:
+	free(buf);
+	return rc;
+}
+
 /** @}
  */
